package dev.shadowsoffire.apotheosis.ench.api;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import dev.shadowsoffire.apotheosis.ench.table.EnchantingStatRegistry;
import java.util.Collections;
import java.util.Set;
import net.minecraft.core.BlockPos;
import net.minecraft.core.Vec3i;
import net.minecraft.core.particles.ParticleOptions;
import net.minecraft.core.particles.ParticleTypes;
import net.minecraft.util.RandomSource;
import net.minecraft.world.item.enchantment.Enchantment;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.LevelReader;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraftforge.common.extensions.IForgeBlock;
import org.jetbrains.annotations.ApiStatus.OverrideOnly;

public interface IEnchantingBlock extends IForgeBlock {
  @OverrideOnly
  default float getMaxEnchantingPower(BlockState state, LevelReader world, BlockPos pos) {
    return 15.0F;
  }
  
  @OverrideOnly
  default float getQuantaBonus(BlockState state, LevelReader world, BlockPos pos) {
    return 0.0F;
  }
  
  @OverrideOnly
  default float getArcanaBonus(BlockState state, LevelReader world, BlockPos pos) {
    return 0.0F;
  }
  
  @OverrideOnly
  default float getQuantaRectification(BlockState state, LevelReader world, BlockPos pos) {
    return 0.0F;
  }
  
  @OverrideOnly
  default int getBonusClues(BlockState state, LevelReader world, BlockPos pos) {
    return 0;
  }
  
  default Set<Enchantment> getBlacklistedEnchantments(BlockState state, LevelReader world, BlockPos pos) {
    return Collections.emptySet();
  }
  
  default void spawnTableParticle(BlockState state, Level level, RandomSource rand, BlockPos pos, BlockPos offset) {
    if (rand.m_188503_(16) == 0 && 
      EnchantingStatRegistry.getEterna(level.m_8055_(pos.m_121955_((Vec3i)offset)), level, pos.m_121955_((Vec3i)offset)) > 0.0F && 
      level.m_46859_(pos.m_7918_(offset.m_123341_() / 2, 0, offset.m_123343_() / 2)))
      level.m_7106_(getTableParticle(state), pos.m_123341_() + 0.5D, pos.m_123342_() + 2.0D, pos.m_123343_() + 0.5D, (offset.m_123341_() + rand.m_188501_()) - 0.5D, (offset.m_123342_() - rand.m_188501_() - 1.0F), (offset
          .m_123343_() + rand.m_188501_()) - 0.5D); 
  }
  
  default ParticleOptions getTableParticle(BlockState state) {
    return (ParticleOptions)ParticleTypes.f_123809_;
  }
  
  default boolean allowsTreasure(BlockState state, LevelReader world, BlockPos pos) {
    return false;
  }
}
